<'
# Copyright (c) 2012-2013,2019 LAAS/CNRS
# All rights reserved.
#
# Redistribution and use  in source  and binary  forms,  with or without
# modification, are permitted provided that the following conditions are
# met:
#
#   1. Redistributions of  source  code must retain the  above copyright
#      notice and this list of conditions.
#   2. Redistributions in binary form must reproduce the above copyright
#      notice and  this list of  conditions in the  documentation and/or
#      other materials provided with the distribution.
#
#                                      Anthony Mallet on Wed Apr 18 2012
#

if {[llength $argv] != 1} { error "expected arguments: component" }
lassign $argv component

# compute handy shortcuts
set comp [$component name]
set COMP [string toupper [$component name]]

lang c
'>
#ifndef H_<"$COMP">_PORTLIB
#define H_<"$COMP">_PORTLIB

#include "h2devLib.h"
#include "posterLib.h"

/* === Port handles ======================================================== */

struct genom_client_ports {
<'foreach p [$component ports out simple] {'>

  struct {
    POSTER_ID id;
  } <"[$p name]">;
<'}'>
<'foreach p [$component ports out multiple] {'>

  struct {
    struct {
      char name[H2_DEV_MAX_NAME];
      POSTER_ID id;
    } *h;
    unsigned int n;
  } <"[$p name]">;
<'}'>

};

#endif /* H_<"$COMP">_PORTLIB */
